#include <amxmodx>
#include <codmod>
#include <hamsandwich>

#define DMG_BULLET (1<<1) 

new bool:ma_klase[33];

new const nazwa[] = "Wyszkolony Snajper";
new const opis[] = "170 % (+int) z awp, 1/2 na natychmiastowe zabicie z noza (PPM), obrazenia nie sa oslabiane przez wytrzymalosc wroga.";
new const bronie = 1<<CSW_DEAGLE | 1<<CSW_AWP | 1<<CSW_ELITE;
new const zdrowie = 20;
new const kondycja = 10;
new const inteligencja = 0;
new const wytrzymalosc = 0;

new Float:redukcja_obrazen_gracza[33];

public plugin_init() 
{
	register_plugin(nazwa, "1.0", "hasztag");
	
	cod_register_advance(cod_get_classid("Snajper"), 40, nazwa, opis, bronie, zdrowie, kondycja, inteligencja, wytrzymalosc);
	RegisterHam(Ham_TakeDamage, "player", "TakeDamage");
        RegisterHam(Ham_TakeDamage, "player", "TakeDamage_wytrzymalosc");
}

public cod_class_enabled(id)
	ma_klase[id] = true;

public cod_class_disabled(id)
	ma_klase[id] = false;

public TakeDamage(this, idinflictor, idattacker, Float:damage, damagebits)
{
	if(!is_user_connected(idattacker))
		return HAM_IGNORED; 
	
	if(!ma_klase[idattacker])
		return HAM_IGNORED;
	
	if(damagebits & DMG_BULLET)
	{
		new weapon = get_user_weapon(idattacker);
		
		if(weapon == CSW_KNIFE && damage > 20.0 && random_num(1,2) == 1) 
			cod_inflict_damage(idattacker, this, float(get_user_health(this))-damage+1.0, 0.0, idinflictor, damagebits);
			
		if(weapon == CSW_AWP)
			cod_inflict_damage(idattacker, this, damage*0.7, 0.7, idinflictor, damagebits);	
	}
	
	return HAM_IGNORED;
}

public TakeDamage_wytrzymalosc(this, idinflictor, idattacker, Float:damage, damagebits)
{
	if(!is_user_connected(idattacker))
		return HAM_IGNORED;

	if(!ma_klase[idattacker])
		return HAM_IGNORED;

	if(!cod_get_user_stamina(this))
		return HAM_IGNORED;

	redukcja_obrazen_gracza[this] = 0.7*(1.0-floatpower(1.1, -0.112311341*cod_get_user_stamina(this)));
	SetHamParamFloat(4, damage/(1.0-redukcja_obrazen_gracza[this]))

	return HAM_IGNORED;
}